org.springframework.data.repository.config

## Enum BootstrapMode

- java.lang.Object
- - java.lang.Enum<BootstrapMode>
  - - org.springframework.data.repository.config.BootstrapMode

All Implemented Interfaces:
  Serializable, Comparable<BootstrapMode>

    public enum BootstrapMode
    extends Enum<BootstrapMode>

Enumeration to define in which way repositories are bootstrapped.

Since:
  2.1
Author:
  Oliver Gierke
See Also:
  `RepositoryConfigurationSource.getBootstrapMode()`

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`DEFAULT` Repository proxies are instantiated eagerly, just like any other Spring bean, except explicitly marked as lazy.
`DEFERRED` Repository bean definitions are considered lazy and clients will get repository proxies injected that will initialize on first access.
`LAZY` Repository bean definitions are considered lazy, lazily inject and only initialized on first use, i.e. the application might have fully started without the repositories initialized.

### Method Summary

All Methods Static Methods Concrete Methods
`static BootstrapMode` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static BootstrapMode[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### DEFAULT

    public static final BootstrapMode DEFAULT

Repository proxies are instantiated eagerly, just like any other Spring bean, except explicitly marked as lazy. Thus, injection into repository clients will trigger initialization.

#### DEFERRED

    public static final BootstrapMode DEFERRED

Repository bean definitions are considered lazy and clients will get repository proxies injected that will initialize on first access. Repository initialization is triggered on application context bootstrap completion.

#### LAZY

    public static final BootstrapMode LAZY

Repository bean definitions are considered lazy, lazily inject and only initialized on first use, i.e. the application might have fully started without the repositories initialized.

### Method Detail

#### values

    public static BootstrapMode[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (BootstrapMode c : BootstrapMode.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static BootstrapMode valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null